<?php

class Wpshop_Installer
{
	private $wpdb;
	private $tables = array('wpshop_orders'=>array('columns'=> array (
												array('Field'=>'order_id'),
												array('Field'=>'order_date'),
												array('Field'=>'order_discount'),
												array('Field'=>'order_payment'),
												array('Field'=>'client_name'),
												array('Field'=>'client_email'),
												array('Field'=>'client_ip'),
												array('Field'=>'order_status'),
												array('Field'=>'order_delivery'),
												array('Field'=>'order_comment'),
												)
											),
							'wpshop_ordered' => array('columns' => array(
												array('Field'=>'ordered_id'),
												array('Field'=>'ordered_pid'),
												array('Field'=>'ordered_name'),
												array('Field'=>'ordered_cost'),
												array('Field'=>'ordered_count'),
												array('Field'=>'ordered_key'),											
											)
										)
							);
	public function __construct()
	{
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->createOrderTable();
		$this->createOptions();
		Wpshop_Forms::getInstance()->checkcforms(Wpshop_Payment::getSingleton()->getPayments());
	}
	
	private function checkTable($tableName)
	{
		$actualColumns = $this->wpdb->get_results("SHOW COLUMNS FROM `{$this->wpdb->prefix}{$tableName}`;");
		foreach($this->tables[$tableName]['columns'] as $neededColumn)
		{
			$find = false;
			foreach($actualColumns as $column)
			{
				if ($neededColumn['Field'] == $column->Field)
				{
					$find = true;
					break;
				}
			}
			if (!$find)
			{
				return false;
			}			
		}
		return true;
	}
	
	
	private function dropTable($tableName)
	{
		$this->wpdb->query("DROP TABLE `{$this->wpdb->prefix}{$tableName}`;");		
		echo mysql_error();
	}
	
	/**
	 * Создает таблицы для сохранения заказов
	 */
	private function createOrderTable()
	{
		if (!$this->checkTable('wpshop_orders'))
		{
			$this->dropTable('wpshop_orders');
			$sql = "CREATE TABLE `{$this->wpdb->prefix}wpshop_orders`
					(
						`order_id` INT NOT NULL AUTO_INCREMENT ,
						`order_date` INT NOT NULL ,
						`order_discount` INT,
						`order_payment` VARCHAR(20),
						`client_name` VARCHAR( 100 ),
						`client_email` VARCHAR( 50 ),
						`client_ip`  VARCHAR( 50 ),
						`order_status` INT NULL,
						`order_delivery` VARCHAR( 50 ),
						`order_comment` TEXT,
						PRIMARY KEY (  `order_id` )
					) ENGINE = INNODB DEFAULT CHARSET=utf8;";
			$this->wpdb->query($sql);
		}
		
		if (!$this->checkTable('wpshop_ordered'))
		{
			$this->dropTable('wpshop_ordered');
			$sql = "CREATE TABLE `{$this->wpdb->prefix}wpshop_ordered`
				(
					`ordered_id` INT NOT NULL AUTO_INCREMENT ,
					`ordered_pid` INT NOT NULL ,
					`ordered_name` VARCHAR( 100 ) NOT NULL,
					`ordered_cost` FLOAT,
					`ordered_count` INT,
					`ordered_key` VARCHAR(100),
					 PRIMARY KEY (  `ordered_id` )
				) ENGINE = INNODB DEFAULT CHARSET=utf8;";
				
			$this->wpdb->query($sql);
		}
	}
	
	private function createOptions()
	{
		add_option("wp-shop_cssfile","default.css");
		add_option("wp-shop_cform",Wpshop_Forms::getInstance()->getDefaultForm());
		add_option("wp-shop_position","top");
		add_option("wp-shop_show-cost",1);
		add_option("wp-shop-link_ie6","");
		add_option("wpshop.email",get_bloginfo('admin_email'));
		
		add_option("wpshop.currency","руб.");
		
		add_option("wpshop.payments.activate","0");
		add_option("wpshop.payments.wm",array('delivery' => array(0=>'postByCountry',1=>'postByWorld',2=>'vizit',3=>'courier')));
		add_option("wpshop.payments.cash",array('delivery'=>array( 0 => 'courier')));		
		add_option("wpshop.payments.bank",array('delivery' => array(0=>'postByCountry',1=>'postByWorld',2=>'vizit',3=>'courier')));
		add_option("wpshop.payments.robokassa",array('login'=>'demo','pass1'=>'Morbid11','pass2'=>'Visions22','delivery' => array(0=>'postByCountry',1=>'postByWorld',2=>'vizit',3=>'courier')));
		add_option("wpshop.payments.paypal",array('cform'=>'wpshop-paypal'));
		add_option("wpshop.payments.post",array('delivery' => array(0=>'postByCountry',1=>'postByWorld')));
		add_option("wpshop.payments.vizit",array('activate'=>1,'delivery'=>array( 0 => 'vizit')));
		
		add_option("wpshop.delivery",array('vizit'=>array('cost'=>0)));
		add_option("wpshop.cart.discount","0");
		add_option("wpshop.cart.minzakaz","0.1");
		add_option("wpshop.cart.minzakaz_info","<br/><br/><h2>Сумма Вашего заказа ниже минимальной. Пожалуйста закажите еще что-нибудь!</h2>");
		
		// Удаляет опцию, так как потеряла свою актуальность
		delete_option("wp-shop_show-variety");
		delete_option("wpshop-linkfor","");
		delete_option("wp-shop-window");
	}
}
